Attribute VB_Name = "basMain"
'MAIN.BAS (basMain) - Ickis <ickis@toctep.com>.

'MMII Weatherspoon Labs <http://toctep.com/>.  All rights reserved.

'Permission to use, copy, modify, and distribute this software and its
'documentation for non-commercial purposes and without fee is hereby granted.

Option Explicit

Public Const CHAT$ = "CHAT"
Public Const DRTL$ = "DRTL"
Public Const DSHR$ = "DSHR"
Public Const STAR$ = "STAR"
Public Const SSHR$ = "SSHR"
Public Const JSTR$ = "JSTR"
Public Const SEXP$ = "SEXP"
Public Const W2BN$ = "W2BN"
Public Const D2DV$ = "D2DV"
Public Const D2XP$ = "D2XP"
Public Const WAR3$ = "WAR3"
Public Const ICON_BLIZZARD& = 1
Public Const ICON_OP& = 2
Public Const ICON_SPEAKER& = 3
Public Const ICON_SYSADMIN& = 4
Public Const ICON_SQUELCHED& = 5
Public Const ICON_SPECTATOR& = 6
Public Const ICON_CHAT& = 7
Public Const ICON_DRTL& = 8
Public Const ICON_DSHR& = 9
Public Const ICON_STAR& = 10
Public Const ICON_SSHR& = 11
Public Const ICON_JSTR& = 12
Public Const ICON_SEXP& = 13
Public Const ICON_W2BN& = 14
Public Const ICON_D2DV& = 15
Public Const ICON_D2XP& = 16
Public Const ICON_WAR3& = 17
Public Const ICON_UNKNOWN& = 18
Public Const FLAG_BLIZZARD& = &H1
Public Const FLAG_OP& = &H2
Public Const FLAG_SPEAKER& = &H4
Public Const FLAG_SYSADMIN& = &H8
Public Const FLAG_SQUELCHED& = &H20
Public Const FLAG_SPECTATOR& = &H40

Public g_ConnectedUsername$
Public g_Username$
Public g_Password$
Public g_Server$
Public g_ChannelName$
Public g_Op As Boolean
Public g_OnTop As Boolean
Public g_Telnet As Boolean

Public Sub Main()
    g_Username = ReadINI("Setup", "Username", FixPath(App.Path) & "assbot.ini")
    g_Password = ReadINI("Setup", "Password", FixPath(App.Path) & "assbot.ini")
    g_Server = ReadINI("Setup", "Server", FixPath(App.Path) & "assbot.ini")
    g_Op = False
    g_OnTop = False
    g_Telnet = False
    Load frmSetup
    Load frmAbout
    Load frmMain
    frmMain.Show
End Sub

'Grok's (of Clan [vL]) RTB colored text subprocedure with slight modifications.
Public Sub AddChat(ParamArray paElements() As Variant)
    Dim i&
    Dim s$
    
    With frmMain.rtfChat
        .SelStart = Len(.Text)
        .SelLength = 0
        .SelColor = RGB(127, 127, 127)
        .SelText = "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] "
        s = "[" & Format(Date, "DD.MM.YY") & " " & Format(Time, "HH:MM:SS") & "] "
        .SelStart = Len(.Text)
        For i = LBound(paElements) To UBound(paElements) Step 2
            .SelStart = Len(.Text)
            .SelLength = 0
            .SelColor = paElements(i)
            .SelText = paElements(i + 1) & Left(vbCrLf, -2 * CLng((i + 1) = UBound(paElements)))
            s = s & paElements(i + 1)
            .SelStart = Len(.Text)
        Next i
    End With
    If g_Telnet Then frmMain.wskTelnet.SendData s & vbCrLf
End Sub

Public Sub ChannelName(strName$)
    Dim i&
    
    frmMain.Caption = App.Title & " - " & strName
    If frmMain.TextWidth(strName & " (" & frmMain.lvwNickList.ListItems.Count & ")") < frmMain.lblChannelName.Width Then
        frmMain.lblChannelName.Caption = strName & " (" & frmMain.lvwNickList.ListItems.Count & ")"
    Else
        For i = Len(strName & "...") To 1 Step -1
            If frmMain.TextWidth(Left(strName, i) & "... (" & frmMain.lvwNickList.ListItems.Count & ")") < frmMain.lblChannelName.Width Then
                frmMain.lblChannelName.Caption = Left(strName, i) & "... (" & frmMain.lvwNickList.ListItems.Count & ")"
                Exit For
            End If
        Next i
    End If
End Sub

Public Sub AddNick(ByVal strKey$, ByVal strName$, lngIcon&)
    Dim i&
    
    i = frmMain.lvwNickList.ListItems.Count + 1
    frmMain.lvwNickList.ListItems.Add i, strKey, strName, 0, lngIcon
End Sub

Public Sub DelNick(ByVal strKey$)
    Dim i&
    
    If frmMain.lvwNickList.ListItems.Count > 1 Then
        For i = 1 To frmMain.lvwNickList.ListItems.Count
            If Left(frmMain.lvwNickList.ListItems(i).Key, InStr(1, frmMain.lvwNickList.ListItems(i).Key, "&") - 1) = strKey Then
                frmMain.lvwNickList.ListItems.Remove i
                Exit For
            End If
        Next i
    Else
        If Left(frmMain.lvwNickList.ListItems(1).Key, InStr(1, frmMain.lvwNickList.ListItems(1).Key, "&") - 1) = strKey Then frmMain.lvwNickList.ListItems.Remove 1
    End If
End Sub

Public Sub EditNick(ByVal strKey$, lngIcon&)
    Dim i&
    
    If frmMain.lvwNickList.ListItems.Count > 1 Then
        For i = 1 To frmMain.lvwNickList.ListItems.Count
            If Left(frmMain.lvwNickList.ListItems(i).Key, InStr(1, frmMain.lvwNickList.ListItems(i).Key, "&") - 1) = strKey Then
            If lngIcon = 0 Then
                Select Case Right(frmMain.lvwNickList.ListItems(i).Key, Len(frmMain.lvwNickList.ListItems(i).Key) - InStr(1, frmMain.lvwNickList.ListItems(i).Key, "&"))
                    Case CHAT: lngIcon = ICON_CHAT
                    Case DRTL: lngIcon = ICON_DRTL
                    Case DSHR: lngIcon = ICON_DSHR
                    Case STAR: lngIcon = ICON_STAR
                    Case SSHR: lngIcon = ICON_SSHR
                    Case JSTR: lngIcon = ICON_JSTR
                    Case SEXP: lngIcon = ICON_SEXP
                    Case W2BN: lngIcon = ICON_W2BN
                    Case D2DV: lngIcon = ICON_D2DV
                    Case D2XP: lngIcon = ICON_D2XP
                    Case WAR3: lngIcon = ICON_WAR3
                    Case Else: lngIcon = ICON_UNKNOWN
                End Select
            End If
            frmMain.lvwNickList.ListItems(i).SmallIcon = lngIcon
            End If
        Next i
    Else
        If lngIcon = 0 Then
            Select Case Right(frmMain.lvwNickList.ListItems(1).Key, Len(frmMain.lvwNickList.ListItems(1).Key) - InStr(1, frmMain.lvwNickList.ListItems(1).Key, "&"))
                Case CHAT: lngIcon = ICON_CHAT
                Case DRTL: lngIcon = ICON_DRTL
                Case DSHR: lngIcon = ICON_DSHR
                Case STAR: lngIcon = ICON_STAR
                Case SSHR: lngIcon = ICON_SSHR
                Case JSTR: lngIcon = ICON_JSTR
                Case SEXP: lngIcon = ICON_SEXP
                Case W2BN: lngIcon = ICON_W2BN
                Case D2DV: lngIcon = ICON_D2DV
                Case D2XP: lngIcon = ICON_D2XP
                Case WAR3: lngIcon = ICON_WAR3
                Case Else: lngIcon = ICON_UNKNOWN
            End Select
        End If
        If Left(frmMain.lvwNickList.ListItems(1).Key, InStr(1, frmMain.lvwNickList.ListItems(1).Key, "&") - 1) = strKey Then frmMain.lvwNickList.ListItems(1).SmallIcon = lngIcon
    End If
End Sub

Public Function Split(ByVal strString$, Optional strDelimiter$, Optional lngLimit& = -1, Optional bCompare As VbCompareMethod = vbBinaryCompare) As Variant
    Dim strRead$
    Dim s$()
    Dim c%
    
    If strDelimiter = "" Then Split = strString
    strRead = ReadUntil(strString, strDelimiter, bCompare)
    Do
        ReDim Preserve s(c)
        s(c) = strRead
        c = c + 1
        If (lngLimit <> -1) And (c >= lngLimit) Then Exit Do
        strRead = ReadUntil(strString, strDelimiter)
    Loop While strRead <> ""
    ReDim Preserve s(c)
    s(c) = strString
    Split = s
End Function

Public Function ReadUntil$(ByRef strString$, strDelimiter$, Optional bCompare As VbCompareMethod = vbBinaryCompare)
    Dim intPos%
                  
    intPos = InStr(1, strString, strDelimiter, bCompare)
    If intPos > 0 Then
        ReadUntil = Left(strString, intPos - 1)
        strString = Mid(strString, intPos + Len(strDelimiter))
    End If
End Function

Public Function HexToDec&(strString$)
    Dim s$
    Dim i&
    Dim c&
    Dim n&
    
    c = Len(strString) - 1
    n = 0
    For i = 1 To Len(strString)
        s = Mid(strString, i, 1)
        n = n + (CInt("&H" & s) * 16 ^ c)
        c = c - 1
    Next i
    HexToDec = n
End Function

Public Sub CenterForm(frmForm As Form)
    frmForm.Left = (Screen.Width - frmForm.Width) \ 2
    frmForm.Top = (Screen.Height - frmForm.Height) \ 2
End Sub

Public Sub HighlightText(ctlControl As Control)
    ctlControl.SelStart = 0
    ctlControl.SelLength = Len(ctlControl.Text)
End Sub

Public Sub WriteINI(wiSection$, wiKey$, wiValue$, wiFile$)
    WritePrivateProfileString wiSection, wiKey, wiValue, wiFile
End Sub

Public Function ReadINI$(riSection$, riKey$, riFile$)
    Dim sRiBuffer$
    Dim sRiValue$
    Dim sRiLong$

    If Dir(riFile$) <> "" Then
        sRiBuffer = String(255, vbNull)
        sRiLong = GetPrivateProfileString(riSection, riKey, Chr(1), sRiBuffer, 255, riFile)
        If Left(sRiBuffer, 1) <> Chr(1) Then
            sRiValue = Left(sRiBuffer, sRiLong)
            ReadINI = sRiValue
        End If
    Else
        ReadINI = ""
    End If
End Function

Public Function FixPath$(strPath$)
    Dim s$
    
    s = strPath
    If Right(s, 1) <> "\" Then s = s & "\"
    FixPath = s
End Function

